/* 2008-06-18, ---rgf, cf. <http://api.openoffice.org/servlets/ReadMsg?list=dev&msgNo=19570>

      New style services possess constructor methods and can be instantiated in a much easier
      way.
*/
-- ***** ooRexx *****
xContext = uno.connect()  -- connect to server and retrieve the XContext

   /* load the UNO class */
clz=uno.loadClass("com.sun.star.script.provider.ScriptURIHelper")

   /* new style service, returns already a XScriptURIHelper interface object! */
xScriptURIHelper = clz~create(xContext,"ooRexx","share")


   /* query the storage URI of this language root directory */
say "language:        " pp("ooRexx")
say "location:        " pp("share")
say "rootStorageURI:  " pp(xScriptURIHelper~getRootStorageURI)
say copies("=",40)

   /* define array of scriptURIs and query their storage URI */
scriptURIS = .array~of( -
   "vnd.sun.star.script:Library1.metaDataInfosShare.rex?language=ooRexx&location=share", -
   "vnd.sun.star.script:Library1.metaDataInfosShare.rex?language=ooRexx&location=user", -
   "vnd.sun.star.script:Library1/metaDataInfosShare.rex?language=ooRexx&location=share", -
   "vnd.sun.star.script:Library1/metaDataInfosShare.rex?language=ooRexx&location=user", -
   "vnd.sun.star.script:pythonSamples.TableSample.py$createTable?language=Python&location=share", -
   "vnd.sun.star.script:Library1.metaDataInfosShare.rex?language=ooRexx&location=vnd.sun.star.expand:${$SYSBINDIR/bootstrap.ini::BaseInstallation}/share/Scripts/oorexx/Library1")

say "Input:  any storageURI or scriptURI with a location of 'user' or 'share'"
say "Output: storageURI or scriptURI according to the service's location ('user' or 'share')"
say
do scriptURI over scriptURIS
   say "input:           " pp(scriptURI)
   storageURI = xScriptURIHelper~getStorageURI(scriptURI)
   say "   -> storageURI:" pp(storageURI)
   say

      /* query script URI from its storage URI */
   say "using above storageURI as input:"
   scriptURI = xScriptURIHelper~getScriptURI(storageURI)
   say "   -> scriptURI: " pp(scriptURI)
   say copies("-",40)
end

::requires uno.cls   -- get the UNO support for ooRexx (exploiting the Java interfaces)


